# -*- coding: UTF-8 -*-

'''
Created on 15.04.2010

@author: gsu
'''

import MySQLdb
import re, shutil, os, sys
from nes_common import logger, rest_client
from nes_common.executor import Executor, DataIntegrityError

log = None

class Context(object):
    cursor = None
    def __init__(self, cursor, config, shopCode, loadDictStatusSender = None):
        self.cursor = cursor
        self.emptyTables = {}
        self.shopCode = shopCode
        self.loadDictStatusSender = loadDictStatusSender
        self.tables = []
        try:
            self.executeMany = config.getboolean('mysql', 'executeMany')
        except:
            self.executeMany = True

    def tableName(self, table):
        if not self.tables.__contains__(table) and self.loadDictStatusSender:
            self.tables.append(table)
            log.info('table = %s' % table)
            dictCSLoadId = self.loadDictStatusSender.sendDictState('Start load dict to db', 'Загрузка справочника в БД кассового сервера', rest_client.STATUS_DURING, tableName=table)
        return table

    def finalize(self):
        return True

class Exec(Executor):
    def __init__(self, host, port, user, password, database, shopCode, config, loadDictStatusSender = None):
        global log
        try:
            commandCommitCount = config.getint('mysql', 'commandCommitCount')
        except:
            commandCommitCount = 5000
        log = logger.Logger().getLogger(shopCode)
        if not password or password == '':
            connection = MySQLdb.connect(host = host, port = port, user=user, db=database)
        else:
            connection = MySQLdb.connect(host = host, port = port, user=user, passwd=password, db=database)
        connection.set_character_set('utf8')
        connection.ping(True)
        context = Context(connection.cursor(), config, shopCode, loadDictStatusSender)
        Executor.__init__(self, shopCode, connection, context, commandCommitCount)

