# -*- coding: UTF-8 -*-
'''
Created on 14.04.2010

@author: gsu
'''

from nes_common.sql_operation import _Insert, _Update as Update, _LastInsertId as LastInsertId, _Select as Select, _Delete as Delete, _DeleteAll
import MySQLdb
from nes_common import logger

class Insert(_Insert):

    cacheOddColumns = {} # кэш со столбцами, которые пропускаем (не пытаемся грузить в БД)

    def execute(self, context):
        self.filterColumns(self.values, context)
        try:
            _Insert.execute(self, context)
        except MySQLdb.IntegrityError, e:
            if e[0] != 1062: # пропускаем ошибку mysql (Duplicate entry)
                raise e

    def filterColumns(self, generateMap, context):
        if not Insert.cacheOddColumns.has_key(self.table):
            Insert.cacheOddColumns[self.table] = []
            realColumns = self.getRealColumns(context)
            for k in generateMap.keys():
                if not k.lower() in realColumns:
                    Insert.cacheOddColumns[self.table].append(k)
                    generateMap.pop(k)
            log = logger.Logger().getLogger(context.shopCode)
            if len(Insert.cacheOddColumns[self.table]) > 0:
                log.warning('Не загружаем поля: %s в таблицу: %s' % (Insert.cacheOddColumns[self.table], self.table))
        else:
            for k in Insert.cacheOddColumns[self.table]:
                generateMap.pop(k)

    def getRealColumns(self, context):
        columns = []
        context.cursor.execute('SHOW COLUMNS FROM %s' % self.table)
        for value in context.cursor:
            columns.append(value[0].lower())
        return columns


class DeleteAll(_DeleteAll):
    def execute(self, context):
        tableName = context.tableName(self.table)
        sql = "DELETE FROM %s " % tableName
        context.cursor.execute(sql)
        context.emptyTables[self.table] = True
