# -*- coding: UTF-8 -*-

import multiprocessing
from nes_common.basictaskrunner import BasicTaskRunner
from nes_common import logger

class MprocTaskRunner(BasicTaskRunner):
    """
    Реализация объекта выполняющего задачи в пуле подпроцессов
    Используется на КС
    """
    def __init__(self):
        self.pool = None
        self.tasks = {}
        self.log = logger.Logger().getLogger('Service')
    
    def addAsyncTask(self, id, function, args):
        self.log.debug('добавление задачи id = %s в пул' % id)
        if id in self.tasks:
            if self.tasks[id].ready() and self.tasks[id].get():
                self.log.debug('задача id = %s выполнена' % id)
                self.tasks[id] = self.pool.apply_async(function, args)
        else:
            self.tasks[id] = self.pool.apply_async(function, args)
            self.log.debug('добавлена новая задача id = %s в пул' % id)

    def stopAllTasks(self):
        if self.pool:
            try:
                self.pool.terminate()
            except:
                pass
            try:
                self.pool.close()
            except:
                pass
            self.pool.join()
    
    def init(self, countOfTasks):
        self.pool = multiprocessing.Pool(countOfTasks)
