'''
Created on 26.10.2011

@author: SerovS
'''
from datetime import datetime, date, time
import simplesql as sql

tables = ['aspectvalueset', 'aspectaluesetvalues', 'tmc']

def insertAspectValueSet(aspectValueSet):
    remaindate = datetime.combine(date.today(), time(0, 0, 0))
    yield sql.Insert(table='aspectvalueset', values={
           'aspectschemecode': aspectValueSet.get('aspectschemecode', 0),
           'aspectvaluesetcode': aspectValueSet.get('aspectvaluesetcode',0),
           'cquant': aspectValueSet.get('cquant', None),
           'price': aspectValueSet.get('price', None),
           'tmc_code': aspectValueSet.get('tmc_code', None),
           'measure': aspectValueSet.get('measure', None),
           'remain': aspectValueSet.get('remain', None),
           'name': aspectValueSet.get('name', None),
           'remaindate': aspectValueSet.get('remaindate', remaindate),
           'packingprice': aspectValueSet.get('packingprice', None),
           })

def deleteAspectValueSet(aspectValueSet):
    yield sql.Delete(table='aspectvalueset',
                     whereFields=['aspectvaluesetcode'],
                     whereValues=(aspectValueSet.get('aspectvaluesetcode', 0),))

def clearAspectValueSet():
    yield sql.DeleteAll(table='aspectvalueset')

def deleteAspectValueSetByCode(code):
    yield sql.Delete(table='aspectvalueset',
                     whereFields=['aspectvaluesetcode'],
                     whereValues=[code])
