import simplesql as sql

def insertShopLabels(group):
    code = group.get('code', None)
    yield sql.Insert(table='shopgrouplabels', values={"code":code, "name":group.get('name', "")})
    for label in group.get('labels', []):
        yield sql.Insert(table='shoplabels', values={"code":label.get('code', None),
                                                     "name":label.get('name', ""),
                                                     "shopgrouplabelcode":code})
def deleteShopLabels(group):
    for i in deleteShopLabelsByCode(group.get('code', None)):
        yield i

def deleteShopLabelsByCode(code):
    yield sql.Delete(table='shopgrouplabels', whereFields=['code'], whereValues=[code])
    yield sql.Delete(table='shoplabels', whereFields=['shopgrouplabelcode'], whereValues=[code])

def clearShopLabels():
    yield sql.DeleteAll('shopgrouplabels')
    yield sql.DeleteAll('shoplabels')
